# Table (1_graphentester)

Package imp

## Class Table

- java.lang.Object
- - imp.Table

    public class Table
    extends Object

### Constructor Summary

Constructors
`Table()` Erzeugt leeres Tabellen-Dokument.
`Table​(String filename)` Erzeugt Tabellen-Dokument aus einer CSV-Datei.
`Table​(String filename, String options)` Erzeugt Tabellen-Dokument aus einer CSV-Datei.
`Table​(String filename, String options, char separator, char quote)` Erzeugt Tabellen-Dokument aus einer CSV-Datei.

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `addColumn()` Fügt eine neue Spalte am Ende der Tabelle an.
`void` `addColumn​(String title)` Fügt eine neue Spalte am Ende der Tabelle an und benennt sie.
`void` `addColumn​(String title, String type)` Fügt eine neue Spalte am Ende der Tabelle an und benennt und typisiert sie.
`TableRow` `addRow()` Fügt eine neue Zeile an das Ende der Tabelle an.
`void` `clearRows()` Löscht alle Zeilen der Tabelle.
`TableRow` `findRow​(String value, int column)` Sucht nach einem bestimmtem Wert in einer Zeile.
`TableRow` `findRow​(String value, String name)` Sucht nach einem bestimmtem Wert in einer Zeile.
`int` `getColumnCount()` Liefert die Anzahl der Spalten in der Tabelle
`double` `getDouble​(int row, int column)` Liefert den Wert einer Zelle als Double-Zahl
`double` `getDouble​(int row, String name)` Liefert den Wert einer Zelle als Double-Zahl
`double[]` `getDoubleColumn​(int column)` Liefert alle Werte einer Spalte als Double-Array.
`double[]` `getDoubleColumn​(String name)` Liefert alle Werte einer Spalte als Double-Array.
`double[]` `getDoubleRow​(int row)` Liefert alle Werte einer Spalte als Double-Array.
`float` `getFloat​(int row, int column)` Liefert den Wert einer Zelle als Float-Zahl
`float` `getFloat​(int row, String name)` Liefert den Wert einer Zelle als Float-Zahl
`float[]` `getFloatColumn​(int column)` Liefert alle Werte einer Spalte als Float-Array.
`float[]` `getFloatColumn​(String name)` Liefert alle Werte einer Spalte als Float-Array.
`float[]` `getFloatRow​(int row)` Liefert alle Werte einer Zeile als Float-Array.
`int` `getInt​(int row, int column)` Liefert den Wert einer Zelle als Integer-Zahl
`int` `getInt​(int row, String name)` Liefert den Wert einer Zelle als Integer-Zahl
`int[]` `getIntColumn​(int column)` Liefert alle Werte einer Spalte als Integer-Array.
`int[]` `getIntColumn​(String name)` Liefert alle Werte einer Spalte als Integer-Array.
`int[]` `getIntRow​(int row)` Liefert alle Werte einer Zeile als Integer-Array.
`TableRow` `getRow​(int i)` Liefert eine Zeile der Tabelle
`int` `getRowCount()` Liefert die Anzahl der Zeilen in der Tabelle
`String` `getString​(int row, int column)` Liefert den Wert einer Zelle als String
`String` `getString​(int row, String name)` Liefert den Wert einer Zelle als String
`String[]` `getStringColumn​(int column)` Liefert alle Werte einer Spalte als String-Array.
`String[]` `getStringColumn​(String name)` Liefert alle Werte einer Spalte als String-Array.
`String[]` `getStringRow​(int row)` Liefert alle Werte einer Spalte als String-Array.
`void` `loadCSV​(String filename)` Liest den Inhalt einer CSV-Datei ohne Kopfzeile (Separator = ';', Kennung für Text = '"').
`void` `loadCSV​(String filename, String options)` Liest den Inhalt einer CSV-Datei (Separator = ';', Kennung für Text = '"').
`void` `loadCSV​(String filename, String options, char separator, char quote)` Liest den Inhalt einer CSV-Datei.
`void` `removeColumn​(int i)` Löscht eine Spalte.
`void` `removeColumn​(String name)` Löscht eine Spalte
`void` `removeRow​(int i)` Löscht eine Zeile
`TableRow[]` `rows()` Liefert die ganze Tabelle als Array von TableRow-Objekten
`void` `saveCSV​(String filename)` Speichert das aktuelle Dokument als CSV-Datei ohne Kopfzeile (Separator = ';', Kennung für Text = '"').
`void` `saveCSV​(String filename, String options)` Speichert das aktuelle Dokument als CSV-Datei (Separator = ';', Kennung für Text = '"').
`void` `saveCSV​(String filename, String options, char separator, char quote)` Speichert das aktuelle Dokument als CSV-Datei.
`void` `saveXML​(String filename)` Speichert die Tabelle als XML-Dokument.
`void` `setDouble​(int row, int column, double value)` Setzt den Wert einer Zelle als Double-Zahl
`void` `setDouble​(int row, String name, double value)` Setzt den Wert einer Zelle als Double-Zahl
`void` `setFloat​(int row, int column, float value)` Setzt den Wert einer Zelle als Float-Zahl
`void` `setFloat​(int row, String name, float value)` Setzt den Wert einer Zelle als Float-Zahl
`void` `setInt​(int row, int column, int value)` Setzt den Wert einer Zelle als Integer-Zahl
`void` `setInt​(int row, String name, int value)` Setzt den Wert einer Zelle als Integer-Zahl
`void` `setString​(int row, int column, String text)` Setzt den Wert einer Zelle als String
`void` `setString​(int row, String name, String text)` Setzt den Wert einer Zelle als String
`void` `trim()` Kürzt alle Einträge der Tabelle um unnötige Leerzeichen am Anfang oder Ende

### Methods inherited from class java.lang.Object

`clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### Table

    public Table()

Erzeugt leeres Tabellen-Dokument.

#### Table

    public Table​(String filename,
                 String options,
                 char separator,
                 char quote)

Erzeugt Tabellen-Dokument aus einer CSV-Datei. Liest den Inhalt einer Datei und erstellt ein Tabellenobjekt mit seinen Werten. Wenn die Datei eine Kopfzeile enthält, fügen Sie "header" in den Parameter options ein. Wenn die Datei keine Kopfzeile hat, dann lassen Sie einfach die Option "header" weg.

Parameters:
  `filename` - Dateiname der CSV-Datei.
  `options` - Geben Sie hier "header" an, wenn die Datei eine Kopfzeile enthält.
  `separator` - Trennzeichen für Spalten (meist ';' oder ',' oder '\t' für Tab)
  `quote` - Kennung für Texte (meist '"').

#### Table

    public Table​(String filename,
                 String options)

Erzeugt Tabellen-Dokument aus einer CSV-Datei. Liest den Inhalt einer Datei und erstellt ein Tabellenobjekt mit seinen Werten (Separator = ';', Kennung für Text = '"'). Wenn die Datei eine Kopfzeile enthält, fügen Sie "header" in den Parameter options ein. Wenn die Datei keine Kopfzeile hat, dann lassen Sie einfach die Option "header" weg.

Parameters:
  `filename` - Dateiname der CSV-Datei.
  `options` - Geben Sie hier "header" an, wenn die Datei eine Kopfzeile enthält.

#### Table

    public Table​(String filename)

Erzeugt Tabellen-Dokument aus einer CSV-Datei. Liest den Inhalt einer Datei ohne Kopfzeile und erstellt ein Tabellenobjekt mit seinen Werten (Separator = ';', Kennung für Text = '"').

Parameters:
  `filename` - Dateiname der CSV-Datei.

### Method Detail

#### loadCSV

    public void loadCSV​(String filename)

Liest den Inhalt einer CSV-Datei ohne Kopfzeile (Separator = ';', Kennung für Text = '"').

Parameters:
  `filename` - Dateiname der CSV-Datei.

#### loadCSV

    public void loadCSV​(String filename,
                        String options)

Liest den Inhalt einer CSV-Datei (Separator = ';', Kennung für Text = '"'). Wenn die Datei eine Kopfzeile enthält, fügen Sie "header" in den Parameter options ein. Wenn die Datei keine Kopfzeile hat, dann lassen Sie einfach die Option "header" weg.

Parameters:
  `filename` - Dateiname der CSV-Datei.
  `options` - Geben Sie hier "header" an, wenn die Datei eine Kopfzeile enthält.

#### loadCSV

    public void loadCSV​(String filename,
                        String options,
                        char separator,
                        char quote)

Liest den Inhalt einer CSV-Datei. Wenn die Datei eine Kopfzeile enthält, fügen Sie "header" in den Parameter options ein. Wenn die Datei keine Kopfzeile hat, dann lassen Sie einfach die Option "header" weg.

Parameters:
  `filename` - Dateiname der CSV-Datei.
  `options` - Geben Sie hier "header" an, wenn die Datei eine Kopfzeile enthält.
  `separator` - Trennzeichen für Spalten (meist ';' oder ',' oder '\t' für Tab)
  `quote` - Kennung für Texte (meist '"').

#### saveCSV

    public void saveCSV​(String filename)

Speichert das aktuelle Dokument als CSV-Datei ohne Kopfzeile (Separator = ';', Kennung für Text = '"').

Parameters:
  `filename` - Dateiname der CSV-Datei.

#### saveCSV

    public void saveCSV​(String filename,
                        String options)

Speichert das aktuelle Dokument als CSV-Datei (Separator = ';', Kennung für Text = '"'). Wenn die Datei eine Kopfzeile enthalten, fügen Sie "header" in den Parameter options ein. Wenn die Datei keine Kopfzeile haben soll, dann lassen Sie einfach die Option "header" weg.

Parameters:
  `options` - Geben Sie hier "header" an, wenn die Datei eine Kopfzeile haben soll.
  `filename` - Dateiname der CSV-Datei.

#### saveCSV

    public void saveCSV​(String filename,
                        String options,
                        char separator,
                        char quote)

Speichert das aktuelle Dokument als CSV-Datei. Wenn die Datei eine Kopfzeile enthalten, fügen Sie "header" in den Parameter options ein. Wenn die Datei keine Kopfzeile haben soll, dann lassen Sie einfach die Option "header" weg.

Parameters:
  `options` - Geben Sie hier "header" an, wenn die Datei eine Kopfzeile haben soll.
  `filename` - Dateiname der CSV-Datei.
  `separator` - Trennzeichen für Spalten (meist ';' oder ',' oder '\t' für Tab)
  `quote` - Kennung für Texte (meist '"').

#### saveXML

    public void saveXML​(String filename)

Speichert die Tabelle als XML-Dokument.

Parameters:
  `filename` - Dateiname des XML-Files

#### addColumn

    public void addColumn()

Fügt eine neue Spalte am Ende der Tabelle an.

#### addColumn

    public void addColumn​(String title)

Fügt eine neue Spalte am Ende der Tabelle an und benennt sie.

Parameters:
  `title` - Bezeichnung der Spalte

#### addColumn

    public void addColumn​(String title,
                          String type)

Fügt eine neue Spalte am Ende der Tabelle an und benennt und typisiert sie.

Parameters:
  `title` - Bezeichnung der Spalte
  `type` - Typ der Spalte (UNKNOWN, DOUBLE, INTEGER, FLOAT)

#### removeColumn

    public void removeColumn​(int i)

Löscht eine Spalte.

Parameters:
  `i` - Nummer der Spalte.

#### removeColumn

    public void removeColumn​(String name)

Löscht eine Spalte

Parameters:
  `name` - Name der Spalte

#### getColumnCount

    public int getColumnCount()

Liefert die Anzahl der Spalten in der Tabelle

Returns:
  Anzahl der Spalten

#### getRowCount

    public int getRowCount()

Liefert die Anzahl der Zeilen in der Tabelle

Returns:
  Anzahl der Zeilen

#### clearRows

    public void clearRows()

Löscht alle Zeilen der Tabelle. Die Spaltenüberschriften und Typen bleiben erhalten.

#### addRow

    public TableRow addRow()

Fügt eine neue Zeile an das Ende der Tabelle an.

Returns:
  ein TableRow-Objekt für diese neue Zeile

#### removeRow

    public void removeRow​(int i)

Löscht eine Zeile

Parameters:
  `i` - Nummer der Zeile

#### getRow

    public TableRow getRow​(int i)

Liefert eine Zeile der Tabelle

Parameters:
  `i` - Nummer der Zeile
Returns:
  TableRow-Objekt für diese Zeile

#### rows

    public TableRow[] rows()

Liefert die ganze Tabelle als Array von TableRow-Objekten

Returns:
  Array von TableRow-Objekten

#### getInt

    public int getInt​(int row,
                      int column)

Liefert den Wert einer Zelle als Integer-Zahl

Parameters:
  `row` - Zeilennummer
  `column` - Spaltennummer
Returns:
  Wert der Zelle

#### getInt

    public int getInt​(int row,
                      String name)

Liefert den Wert einer Zelle als Integer-Zahl

Parameters:
  `row` - Zeilennummer
  `name` - Name der Spalte
Returns:
  Wert der Zelle

#### setInt

    public void setInt​(int row,
                       int column,
                       int value)

Setzt den Wert einer Zelle als Integer-Zahl

Parameters:
  `row` - Zeilennummer
  `column` - Spaltennummer
  `value` - neuer Wert der Zelle

#### setInt

    public void setInt​(int row,
                       String name,
                       int value)

Setzt den Wert einer Zelle als Integer-Zahl

Parameters:
  `row` - Zeilennummer
  `name` - Name der Spalte
  `value` - neuer Wert der Zelle

#### getIntRow

    public int[] getIntRow​(int row)

Liefert alle Werte einer Zeile als Integer-Array.

Parameters:
  `row` - Nummer der Zeile
Returns:
  int-Array, dass alle Werte der Zeile enthält

#### getIntColumn

    public int[] getIntColumn​(int column)

Liefert alle Werte einer Spalte als Integer-Array.

Parameters:
  `column` - Nummer der Spalte
Returns:
  int-Array, dass alle Werte der Spalte enthält

#### getIntColumn

    public int[] getIntColumn​(String name)

Liefert alle Werte einer Spalte als Integer-Array.

Parameters:
  `name` - Name der Spalte
Returns:
  int-Array, dass alle Werte der Spalte enthält

#### getFloat

    public float getFloat​(int row,
                          int column)

Liefert den Wert einer Zelle als Float-Zahl

Parameters:
  `row` - Zeilennummer
  `column` - Spaltennummer
Returns:
  Wert der Zelle

#### getFloat

    public float getFloat​(int row,
                          String name)

Liefert den Wert einer Zelle als Float-Zahl

Parameters:
  `row` - Zeilennummer
  `name` - Name der Spalte
Returns:
  Wert der Zelle

#### setFloat

    public void setFloat​(int row,
                         int column,
                         float value)

Setzt den Wert einer Zelle als Float-Zahl

Parameters:
  `row` - Zeilennummer
  `column` - Spaltennummer
  `value` - neuer Wert der Zelle

#### setFloat

    public void setFloat​(int row,
                         String name,
                         float value)

Setzt den Wert einer Zelle als Float-Zahl

Parameters:
  `row` - Zeilennummer
  `name` - Name der Spalte
  `value` - neuer Wert der Zelle

#### getFloatRow

    public float[] getFloatRow​(int row)

Liefert alle Werte einer Zeile als Float-Array.

Parameters:
  `row` - Nummer der Zeile
Returns:
  int-Array, dass alle Werte der Zeile enthält

#### getFloatColumn

    public float[] getFloatColumn​(int column)

Liefert alle Werte einer Spalte als Float-Array.

Parameters:
  `column` - Nummer der Spalte
Returns:
  int-Array, dass alle Werte der Spalte enthält

#### getFloatColumn

    public float[] getFloatColumn​(String name)

Liefert alle Werte einer Spalte als Float-Array.

Parameters:
  `name` - Name der Spalte
Returns:
  int-Array, dass alle Werte der Spalte enthält

#### getDouble

    public double getDouble​(int row,
                            int column)

Liefert den Wert einer Zelle als Double-Zahl

Parameters:
  `row` - Zeilennummer
  `column` - Spaltennummer
Returns:
  Wert der Zelle

#### getDouble

    public double getDouble​(int row,
                            String name)

Liefert den Wert einer Zelle als Double-Zahl

Parameters:
  `row` - Zeilennummer
  `name` - Name der Spalte
Returns:
  Wert der Zelle

#### setDouble

    public void setDouble​(int row,
                          int column,
                          double value)

Setzt den Wert einer Zelle als Double-Zahl

Parameters:
  `row` - Zeilennummer
  `column` - Spaltennummer
  `value` - neuer Wert der Zelle

#### setDouble

    public void setDouble​(int row,
                          String name,
                          double value)

Setzt den Wert einer Zelle als Double-Zahl

Parameters:
  `row` - Zeilennummer
  `name` - Name der Spalte
  `value` - neuer Wert der Zelle

#### getDoubleRow

    public double[] getDoubleRow​(int row)

Liefert alle Werte einer Spalte als Double-Array.

Parameters:
  `row` - Nummer der Spalte
Returns:
  int-Array, dass alle Werte der Spalte enthält

#### getDoubleColumn

    public double[] getDoubleColumn​(int column)

Liefert alle Werte einer Spalte als Double-Array.

Parameters:
  `column` - Nummer der Spalte
Returns:
  int-Array, dass alle Werte der Spalte enthält

#### getDoubleColumn

    public double[] getDoubleColumn​(String name)

Liefert alle Werte einer Spalte als Double-Array.

Parameters:
  `name` - Name der Spalte
Returns:
  int-Array, dass alle Werte der Spalte enthält

#### getString

    public String getString​(int row,
                            int column)

Liefert den Wert einer Zelle als String

Parameters:
  `row` - Zeilennummer
  `column` - Spaltennummer
Returns:
  Wert der Zelle

#### getString

    public String getString​(int row,
                            String name)

Liefert den Wert einer Zelle als String

Parameters:
  `row` - Zeilennummer
  `name` - Name der Spalte
Returns:
  Wert der Zelle

#### setString

    public void setString​(int row,
                          int column,
                          String text)

Setzt den Wert einer Zelle als String

Parameters:
  `row` - Zeilennummer
  `column` - Spaltennummer
  `text` - neuer Wert der Zelle

#### setString

    public void setString​(int row,
                          String name,
                          String text)

Setzt den Wert einer Zelle als String

Parameters:
  `row` - Zeilennummer
  `name` - Name der Spalte
  `text` - neuer Wert der Zelle

#### getStringRow

    public String[] getStringRow​(int row)

Liefert alle Werte einer Spalte als String-Array.

Parameters:
  `row` - Nummer der Spalte
Returns:
  int-Array, dass alle Werte der Spalte enthält

#### getStringColumn

    public String[] getStringColumn​(int column)

Liefert alle Werte einer Spalte als String-Array.

Parameters:
  `column` - Nummer der Spalte
Returns:
  int-Array, dass alle Werte der Spalte enthält

#### getStringColumn

    public String[] getStringColumn​(String name)

Liefert alle Werte einer Spalte als String-Array.

Parameters:
  `name` - Name der Spalte
Returns:
  int-Array, dass alle Werte der Spalte enthält

#### findRow

    public TableRow findRow​(String value,
                            int column)

Sucht nach einem bestimmtem Wert in einer Zeile.

Parameters:
  `value` - Wert der gesucht werden soll
  `column` - Nummer der Spalte, die durchsucht werden soll
Returns:
  TableRow-Objekt der Zeile, wenn der Wert gefunden wurde, sonst null

#### findRow

    public TableRow findRow​(String value,
                            String name)

Sucht nach einem bestimmtem Wert in einer Zeile.

Parameters:
  `value` - Wert der gesucht werden soll
  `name` - Name der Spalte, die durchsucht werden soll
Returns:
  TableRow-Objekt der Zeile, wenn der Wert gefunden wurde, sonst null

#### trim

    public void trim()

Kürzt alle Einträge der Tabelle um unnötige Leerzeichen am Anfang oder Ende